option linesize = 100 pagesize = 9999 formdlim = '-' mprint;

%let execpath = " ";
%let Path = " ";
%macro setexecpath;
  %let execpath = %sysfunc(getoption(sysin));
  %if %length(&execpath) = 0 %then
    %let execpath = %sysget(sas_execfilepath);
  data _null_;
    do i = length("&execpath") to 1 by -1;
      if substr("&execpath", i, 1) = "\" then do;
        call symput("Path", substr("&execpath", 1, i));
        stop;
      end;
    end;
  run;
%mend setexecpath;
%setexecpath;
libname Out "&Path.";
%include "&Path.stab_v401.sas";
%include "&Path.stabcox_v200.sas";


/*
UϐƌQϐ
\̕ύX\Ȃ߃R[fBȌtH[}bgݒ𐄏܂
, ^œ͂ĂĂȂWvł܂

̗͐̕\tɂȂĂ܂ł
R[fBOƑ: FHISTYN  ^̉Ƒ: FHISTYNT
̗WvĂ܂, o͂鏇ς܂
*/


proc format;
  value falloc 1 = "Active1" 2 = "Active2" 3 = "Placebo";
  value fyn 0 = "-" 1 = "+";
  value fsex 1 = "M" 2 = "F";
  value fgroup 1 = "Placebo" 2 = "Active";
run;


data test;
call streaminit(20181203);
do id = 1 to 200;
  trt = rand("Table", 0.3, 0.3, 0.4);
  sex = rand("Table", 0.5, 0.5);
  fhist = rand("Table", 0.5, 0.5) - 1;
  if fhist = 0 then tfhist = "-";
  else if fhist = 1 then tfhist = "+";
  age = rand("Normal", 30);
  height = rand("Normal", 170, 5.5);
  hist = rand("Table", 0.5, 0.5) - 1;
  comp = rand("Table", 0.5, 0.5) - 1;
  if rand("Uniform") > 0.95 then comp = .; /* missing */
  weight = rand("Normal", 70, 9);
  ttrt = put(trt, falloc.);
  output;
end;
format trt falloc. sex fsex. fhist hist comp fyn.;
run;

data testcox;
  call streaminit(150306);
  length strata $20.;
  tc = 12;  /* time to termination */
  h1 = 0.15; n1 = 100;
  h2 = 0.07; n2 = 100;
  array h[*] h1-h2; array n[*] n1-n2;
  do group = 1 to 2;
    do i = 1 to n[group];
      time = rand('exponential') / h[group]; event = 1;
      /* termination */
      if time > tc then do; time = tc; event = 0; end;
      /* random censoring */
      if rand('Uniform') > 0.9 then do; event = 0; end;
      w = group;
      marker = rand("Uniform");
     output;
    end;
  end;
  format group fgroup.;
  keep time event group w marker;
run;



%let data   = test;         /* ̓f[^Zbg */
%let out    = out1;         /* o̓f[^Zbg */
%let group  = trt;          /* Qϐ */
%let pvalue = 1;            /* Pl̏o (0: o͂Ȃ, 1: o͂) */
%let color  = 1;            /* F̗L (0: Ȃ, 1: ) */
%tableInit();
%tableMake(cont, age, "Age (continuous)", round = 0.1);
%tableMake(ordr, age, "Age (ordinal)", round = 0.1);
%tableMake(cont, height, "Height (continuous)", round = 0.01);
%tableMake(disc, sex, "Sex  \  No. (%)");
%tableMake(disc, fhist, "Familial history  \   No. (%)");
%tableMake(disc, tfhist, "Familial history  \   No. (%)");
%tableMake(disc, hist, "Previous history  \  No. (%)");
%tableMake(disc, comp, "Complication  \  No. (%)");
%tableMake(disc, comp, "Complication (with missing)  \  No. (%)", missing = 1);
%tableOut();



%let data   = test;         /* ̓f[^Zbg */
%let out    = out2;         /* o̓f[^Zbg */
%let group  = ;             /* Qϐ */
%let pvalue = 0;            /* Pl̏o (0: o͂Ȃ, 1: o͂) */
%let color  = 1;            /* F̗L (0: Ȃ, 1: ) */
%tableInit();
%tableMake(cont, age, "Age (continuous)", round = 0.1);
%tableMake(ordr, age, "Age (ordinal)", round = 0.1);
%tableMake(cont, height, "Height (continuous)", round = 0.01);
%tableMake(disc, sex, "Sex  \  No. (%)");
%tableMake(disc, fhist, "Familial history  \   No. (%)");
%tableMake(disc, tfhist, "Familial history  \   No. (%)");
%tableMake(disc, hist, "Previous history  \  No. (%)");
%tableMake(disc, comp, "Complication  \  No. (%)");
%tableMake(disc, comp, "Complication (with missing)  \  No. (%)", missing = 1);
%tableOut();



%let data   = test;         /* ̓f[^Zbg */
%let out    = out3;         /* o̓f[^Zbg */
%let group  = ttrt;         /* Qϐ */
%let pvalue = 0;            /* Pl̏o (0: o͂Ȃ, 1: o͂) */
%let color  = 0;            /* F̗L (0: Ȃ, 1: ) */
%tableInit();
%tableMake(cont, age, "Age (continuous)", round = 0.1);
%tableMake(ordr, age, "Age (ordinal)", round = 0.1);
%tableMake(cont, height, "Height (continuous)", round = 0.01);
%tableMake(disc, sex, "Sex  \  No. (%)");
%tableMake(disc, fhist, "Familial history  \   No. (%)");
%tableMake(disc, tfhist, "Familial history  \   No. (%)");
%tableMake(disc, hist, "Previous history  \  No. (%)");
%tableMake(disc, comp, "Complication  \  No. (%)");
%tableMake(disc, comp, "Complication (with missing)  \  No. (%)", missing = 1);
%tableOut();



%let data   = testcox;      /* ̓f[^Zbg */
%let out    = out4;         /* o̓f[^Zbg */
%let time   = time;         /* ԕϐ */
%let event  = event;        /* Cxgϐ */
%let censorvalue = 0;       /* ł؂l */
%let color  = 1;            /* F̗L (0: Ȃ, 1: ) */
%phregInit();
%phregMake(group, "Treatment");
%phregMake(marker, "Biomarker", aclass = 0);
%phregOut();



/* Output */
%outputInit("&Path.stab_example.xls");
%outputMake(out1, "Table1", "Table 1: Patient characteristics");
%outputMake(out2, "Table2", "Table 2: Patient characteristics (no group, no p-value)");
%outputMake(out3, "Table3", "Table 3: Patient characteristics (no p-value, no color)");
%outputMake(out4, "Table4", "Table 4: Univariate and multivariate analyses for OS with Cox regression models", cox = 1);
%outputOut();



/*
eTu}ÑIvV


%tableInit(
  nprint = 1, footer = 1, font = "Times New Roman",
  hlabel = "Characteristic", slabel = "Study population"
);

nprint - TvTCY̏o
  0: o͂Ȃ
  1: o͂ (default)
footer - 쐬̏o
  0: o͂Ȃ
  1: o͂ (default)
hlabel - x
  "Characteristic": (default)
slabel - PQ̏ꍇ̃x
  "Study population": (default)
font - o̓tHg
  "Times New Roman": (default)
  "MS PMincho": {ꂪ܂܂ꍇMS PMincho̓{ΉtHgɕύXKv
  "MS PGothic": {ꂪ܂܂ꍇMS PMincho̓{ΉtHgɕύXKv



%tableMake(
  type, var, label, round = 0.1, exact = 1, missing = 0, weight = 0
);

type - ϐ̌^w
  cont: Aϐ (ςƕW΍Wv, Welch^t or ANOVAgp)
  ordr: ϐ (lƔ͈͂Wv, Wilcoxon or Kruskal-Wallisgp)
  disc: Uϐ (pxƊWv, ͌q)
var - ͂ϐw
label - \xw
round - Aϐ܂͏ϐ̐lۂ߂̃IvV
exact - Uϐ̌ɂ
  0: ҃Zx5̃ZꍇFisher's exact test
     łȂꍇɃJC挟gp
  1: Fisher's exact testgp (default)
missing - Uϐ̏WvɂČ\邩ۂ
  0: \Ȃ (default)
  1: \
weight - dݕϐ (ʏ͎gpȂ)



%outputInit(
  file
);

file - o͂t@C
  KvɉăpXw肵܂
  gq ".xls" Kw肷邱ƁB



%outputMake(
  out, sheet, title, abscolwidth="40,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7", cox = 0
);

out - o͂f[^Zbg
  %tableInit() &amp; %tableMake() gpĐf[^Zbg
sheet - o̓V[g
  Excel ̃V[g̐Ɉ̂̓G[ł܂̂łӂ
title - \̃^Cg
  sڂɏo͂\^Cg̓ew肵܂
abscolwidth - 
  Excel ̗񕝂J}؂Ŏw肵܂ (̂̓ftHĝ܂܂ővł)
cox - Cox Ãe[up abscolwidth 𒲐邩ǂw肵܂
  0: Ȃ (default)
  1:  (Cox ÂƂ͎w𐄏)



%outputOut();

͂܂B
*/
